﻿--[[
	Author: darcey.lloyd@gmail.com
--]]
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- Local vars
local MTTVersion = "1.0.6";
local MTTDebug = true;

local MTTInCombat = false;
local MTTFrame;
local MTTDragFrame;
local MTTDragFrameAlignment = "TOPLEFT";
local MTTW = 20;
local MTTH = 20;
-- local tipTable = {};
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- Create processor frame
MTTFrame = CreateFrame("frame","MTTFrame");
MTTFrame:RegisterEvent("VARIABLES_LOADED");
MTTFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
MTTFrame:RegisterEvent("PLAYER_REGEN_DISABLED")
MTTFrame:RegisterEvent("PLAYER_REGEN_ENABLED")
MTTFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA");
MTTFrame:RegisterEvent("ZONE_CHANGED_INDOORS");
MTTFrame:RegisterEvent("ZONE_CHANGED");
--MTTFrame:RegisterEvent("PLAYER_LOGOUT");
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- MTTFrame update handler
MTTFrame:SetScript("OnUpdate", function(self) MTTUpdateHandler() end);
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



-- Setup MTTFrame events and handle those events
MTTFrame:SetScript("OnEvent", function(self,event,addonName)
    -- print("EVENT: " .. event);

	if (event == "ADDON_LOADED") then

	elseif (event == "VARIABLES_LOADED") then
        print(" ");
        print("MoveToolTip (DTip) v" .. MTTVersion .. "");
        print("MoveToolTip: Type /mtt for usage information and options.")

	elseif (event == "ZONE_CHANGED") then

	elseif (event == "ZONE_CHANGED_NEW") then

	elseif (event == "ZONE_CHANGED_NEW_AREA") then

	elseif (event == "ZONE_CHANGED_INDOORS") then

	elseif (event == "PLAYER_ENTERING_WORLD") then
		initMTT();
	elseif (event == "PLAYER_REGEN_DISABLED") then
		MTTInCombat = true;
	elseif (event == "PLAYER_REGEN_ENABLED") then
		MTTInCombat = false;
	else
		-- print("MTT: WARNING: Unhandled event: [" .. event .. "]");
	end
end);
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function MTTUpdateHandler()

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #




-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function initMTT()
    initVarsPersistentVars();

    -- MTT Drag frame setup
    MTTDragFrame = CreateFrame("Frame", "MTTDragFrame", UIParent)
    MTTDragFrame:SetFrameStrata("tooltip"); -- background, low, medium, high, dialog, fullscreen, tooltip
    MTTDragFrame:SetWidth(MTTW)
    MTTDragFrame:SetHeight(MTTH)
    MTTDragFrame:SetMovable(true);
    -- local t = MTTDragFrame:CreateTexture(nil,"BACKGROUND")
    -- t:SetTexture("Interface\\AddOns\\DMouse\\images\\pointer2.tga")
    -- t:SetAllPoints(MTTDragFrame)
    -- MTTDragFrame.texture = t
    MTTDragFrame.texture = MTTDragFrame:CreateTexture(nil, "BACKGROUND")
    MTTDragFrame.texture:SetAllPoints(true)
    MTTDragFrame.texture:SetColorTexture(1.0, 0.0, 0.0, 0.75)

    -- TOP", "RIGHT" "BOTTOM" "LEFT" "TOPRIGHT", "TOPLEFT", "BOTTOMLEFT", "BOTTOMRIGHT", "CENTER"
    -- print("MTTDB X,Y = " .. MTTDB["x"] .. "," .. MTTDB["y"]);
    MTTDragFrame:ClearAllPoints(true);
    MTTDragFrame:SetPoint(MTTDragFrameAlignment,MTTDB["x"],MTTDB["y"]);

    MTTDragFrame:EnableMouse(true);
    MTTDragFrame:SetClampedToScreen(true);
    MTTDragFrame:SetMovable(true);
    MTTDragFrame:SetResizable(true);

    MTTDragFrame:Show();

    local scrW = GetScreenWidth() * UIParent:GetEffectiveScale();
    local scrH = GetScreenHeight() * UIParent:GetEffectiveScale();
    -- print(scrW .. " x " .. scrH);



    -- MTTDragFrame:HookScript("OnClick", function(self, button)
    --     print(self:GetName() .. " clicked with " .. button)
    --    end)

    MTTDragFrame:SetScript("OnMouseDown", MTTStartDrag)
    MTTDragFrame:SetScript("OnMouseUp", MTTStopDrag)



    ItemRefTooltip:SetOwner(MTTDragFrame, "TOPLEFT")
	ItemRefTooltip:ClearAllPoints()
    ItemRefTooltip:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 0, 0)






    hooksecurefunc("GameTooltip_SetDefaultAnchor", MTTToolTipHandler);





    -- Setup slash commands (Note: SLASH_<SlashCommandName> is the pickup, add number for multiple slash commands)
    SLASH_MTTCommand1 = "/mtt";
    SLASH_MTTCommand1 = "/MTT";
	SlashCmdList["MTTCommand"] = MTTSlashCommandHandler;






    -- State init
    MTTDragFrame:Hide();

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






function MTTToolTipHandler(self)
    -- print(self);
    -- local w = self:GetWidth();
    -- local h = self:GetHeight();
    -- print(w .. "," .. h);

    self:SetOwner(MTTDragFrame,"ANCHOR_NONE");
    self:ClearAllPoints(true);
    self:SetPoint("BOTTOMRIGHT", MTTDragFrame)

    if (ItemRefTooltip) then
        -- ItemRefTooltip:SetOwner(MTTDragFrame, "ANCHOR_NONE");
        ItemRefTooltip:SetPoint("TOPLEFT", MTTDragFrame)
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #






function MTTStartDrag(self, button)
    if button == "LeftButton" and not self.isMoving then
        self:StartMoving();
        self.isMoving = true;
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #



function MTTStopDrag(self, button)
    if button == "LeftButton" and self.isMoving then
        self:StopMovingOrSizing();
        self.isMoving = false;
        point, relativeTo, relativePoint, x, y = self:GetPoint();
        x = self:GetLeft();
        y = self:GetBottom();
        local scrW = GetScreenWidth();
        local scrH = GetScreenHeight();
        MTTDB["x"] = x;
        MTTDB["y"] = y-scrH+MTTH;
        -- print(scrW .. " x " .. scrH);
        -- print(x .. "," .. y);
        -- print("SETTING MTTDB[x] = " .. MTTDB["x"]);
        -- print("SETTING MTTDB[y] = " .. MTTDB["y"]);
    end
end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #





function MTTCheckDragFramePos(x,y)
    if (x < 0) then
        x = 0;
    end

    if (y < 0) then
        y = 0;
    end

    -- MTTDragFrame:setPoint(MTTDragFrameAlignment,x,y);
    MTTDragFrame:SetPoint("TOPLEFT", x, y)

end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #












-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #
function MTTSlashCommandHandler(cmd)
	if (cmd == nil or cmd == "" or string.find(cmd, "help") ~= nil) then
		print(" ");
		print("MoveToolTip (DTip) v" .. MTTVersion .. ":");
		print("  /mtt hide");
		print("  /mtt show");
		return;
	end


	if (cmd == "hide") then
		MTTDragFrame:Hide();
		return;
	end


	if (cmd == "show") then
		MTTDragFrame:Show();
		return;
	end

	-- Coming soon to a cinema near you
    -- if (cmd == "menu") then
    --     InterfaceOptionsFrame_OpenToCategory(DMouseDB["DMOptions"].Mainbar);
    --     InterfaceOptionsFrame_OpenToCategory(DMouseDB["DMOptions"].Mainbar);
	-- 	return;
	-- end


end
-- # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # # #







